<script>
  import { fade, scale } from "svelte/transition";
  import { flip } from "svelte/animate";
  import { quintOut } from "svelte/easing";
  import Header from "./header.svelte";
  import Footer from "./footer.svelte";
  import Modal from "./modal.svelte";
  import Loading from "./loading.svelte";

  export let menu, originalProjects;

  let projectsEl;
  let projects = originalProjects.slice();

  let categories = new Set();
  projects.forEach(
    (p) => (categories = new Set([...categories, ...p.categories]))
  );
  categories = Array.from(categories);

  function filter(event) {
    const cat = event.target.value;

    if (cat == "all") {
      projects = originalProjects.slice();
      scrollToProjects();
      return;
    }

    projects = originalProjects.filter((p) => p.categories.indexOf(cat) != -1);
    scrollToProjects();
  }

  function scrollToProjects() {
    setTimeout(() => {
      projectsEl.scrollIntoView({
        block: "start",
        inline: "start",
        behavior: "smooth",
      });
    }, 0);
  }

  const hash = (str) => str.toLowerCase().replace(/[^a-z0-9-]+/gi, "-");

  let openProject = false;
  let donateLink = false;
  let loaded;
  $: {
    if (!donateLink) {
      loaded = false;
    }
  }

  function openGreatestNeed(e) {
    if (e) e.preventDefault();
    forward("#greatest-need");
    openProject = false;
    donateLink =
      "https://secure.givelively.org/donate/wildwood-sanitarium-incorporated/greatest-need";
  }

  function openProjectModal() {
    forward(`#${hash(this.title)}`);
    openProject = this;
  }

  function openDonate(e) {
    if (!this.link.includes("givelively.org")) return;
    e.preventDefault();
    donateLink = this.link;
    openProject = false;
    forward(`#${hash(this.title)}/donate`, true);
  }

  function forward(hash, replace = false) {
    if (replace) {
      history.replaceState(undefined, undefined, hash);
    } else {
      history.pushState(undefined, undefined, hash);
    }
  }

  let movedByJS = false;

  function closeModal() {
    window.history.back();
    movedByJS = true;
  }

  // Handle back button
  window.addEventListener("popstate", function (event) {
    if (!movedByJS) goto();
    movedByJS = false;
  });

  // Open correct modal
  function goto() {
    if (!location.hash) {
      donateLink = false;
      openProject = false;
      return;
    }

    let slug, type;
    [slug, type] = location.hash.substr(1).split("/");

    let project;
    for (let p of originalProjects) {
      if (hash(p.title) == slug) {
        project = p;
        break;
      }
    }

    if (!project) {
      openGreatestNeed();
      return;
    }

    switch (type) {
      case "donate":
        donateLink = project.link;
        openProject = false;
        break;
      default:
        openProject = project;
        donateLink = false;
    }

    let loc = `#${hash(project.title)}`;

    if (type) {
      loc += `\${type}`;
    }

    forward("#", true);
    forward(loc);
  }

  // Open modal on load
  goto();
</script>

<Header {menu} />
<main id="main">
  <section id="splash">
    <div class="content">
      <h1>Give to Wildwood Health Institute</h1>
      <p>
        Thank you for your interest in supporting Wildwood Health Institute.
        Your financial aid will help us continue provide physical, mental, and
        spiritual healing to those in need.
      </p>
    </div>
  </section>

  <section id="projects" bind:this={projectsEl}>
    <h2>Projects</h2>
    <p>
      Give to one the projects below or donate towards our
      <a
        on:click={openGreatestNeed}
        href="https://secure.givelively.org/donate/wildwood-sanitarium-incorporated/greatest-need"
        target="_blank"
      >
        greatest need.
      </a>
    </p>
    <div id="filter">
      <label>
        Filter Projects
        <select on:input={filter}>
          <option value="all">Show all Projects</option>
          {#each categories as cat}
            <option>{cat}</option>
          {/each}
        </select>
      </label>
    </div>
    <div class="grid">
      {#each projects as project (project)}
        <div
          class="project"
          on:click={openProjectModal.bind(project)}
          animate:flip={{ delay: 200, duration: 250, easing: quintOut }}
          transition:scale={{ start: 0.95, duration: 300 }}
        >
          <picture>
            <source srcset="img/{project.img}.webp" type="image/webp" />
            <source srcset="img/{project.img}.jpg" type="image/jpg" />
            <img src="img/{project.img}.jpg" alt={project.title} />
          </picture>
          <div class="content">
            <h4 class="title">{project.title}</h4>
          </div>
        </div>
      {/each}
      <div class="project empty" />
      <div class="project empty" />
      <div class="project empty" />
    </div>
  </section>

  <Modal
    title={openProject.title}
    bind:visible={openProject}
    on:close={closeModal}
  >
    {#if openProject}
      <div class="modal">
        {#if openProject.goal}
          <p class="goal">Goal: ${openProject.goal.toLocaleString("en")}</p>
        {/if}
        <picture>
          <source srcset="img/{openProject.img}.webp" type="image/webp" />
          <source srcset="img/{openProject.img}.jpg" type="image/jpg" />
          <img src="img/{openProject.img}.jpg" alt={openProject.title} />
        </picture>
        <p>{openProject.desc}</p>
        <a
          on:click={openDonate.bind(openProject)}
          href={openProject.link}
          class="button donate"
          target="_blank"
        >
          Donate
        </a>
      </div>
    {/if}
  </Modal>

  <Modal title="Donate now" bind:visible={donateLink} on:close={closeModal}>
    <div class="overlap">
      <iframe
        title="Donate now"
        class="givelively"
        src={donateLink}
        frameborder="0"
        on:load={() => (loaded = true)}
      />
      {#if !loaded}
        <div class="loading" out:fade>
          <Loading />
        </div>
      {/if}
    </div>
  </Modal>
</main>
<Footer />

<style>
  #splash {
    width: 100%;
    max-width: 100vw;
    min-height: 40vh;
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-end;
    align-items: flex-start;
    padding: 40px;
    margin-bottom: 50px;
    box-sizing: border-box;
    background: linear-gradient(to top right, #0c1d24aa 35%, #0003 70%),
      url("../img/splash.jpg");
    background-size: cover;
    background-position: center;
  }

  #splash .content {
    width: 100%;
    max-width: 1440px;
    margin: 0 auto;
    color: #fff;
    text-shadow: 0 2px 2px #0004;
  }

  #splash p {
    margin: 0;
    max-width: 640px;
  }

  #projects {
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-start;
    align-items: flex-start;
    min-height: 450px;
  }

  #projects h2,
  #projects p {
    margin: 5px 0;
  }

  #filter {
    margin-bottom: 20px;
  }

  #filter label {
    font-size: 16px;
  }

  #filter select {
    appearance: none;
    -webkit-appearance: none;
    -mox-appearance: none;
    background-color: transparent;
    background-image: url("../img/green-down.png");
    background-repeat: no-repeat;
    background-size: 15px;
    background-position: calc(100% - 10px) 55%;
    border: 0;
    border-bottom: 1px solid #146647;
    border-radius: 0;
    padding-left: 0;
    padding-right: 25px;
  }

  #projects .grid {
    width: 100%;
    display: grid;
    --gap: 40px;
    --cols: 4;
    grid-gap: var(--gap);
    grid-template-columns: repeat(auto-fit, minmax(330px, 1fr));
  }

  .project {
    color: #fff;
    border-radius: 3px;
    overflow: hidden;
    transition: transform 200ms, filter 200ms;
    filter: drop-shadow(0 1px 2px #0004);
    cursor: pointer;
  }

  .project:hover {
    transform: scale(1.03);
    filter: drop-shadow(0 3px 6px #0004);
  }

  .project.empty {
    cursor: default;
  }

  .project img {
    width: 100%;
    object-fit: cover;
    display: block;
  }

  .project .content {
    padding: 10px 15px;
    background: #5abb93;
  }

  .project .title {
    margin: 0;
    letter-spacing: 0.5px;
    font-size: 1.1em;
    font-weight: 400;
  }

  .modal .goal {
    font-family: "Lato", sans-serif;
    font-weight: 400;
    margin-top: 5px;
  }

  .modal img {
    width: 100%;
    height: 268px;
    object-fit: cover;
    border-radius: 3px;
  }

  .modal .donate {
    color: #fff;
    background: #5abb93;
    padding: 10px 15px;
    border-radius: 3px;
    margin-bottom: 20px;
  }

  .givelively {
    width: 100%;
    height: 60vh;
    min-height: 425px;
  }

  .overlap {
    position: relative;
  }

  .overlap .loading {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: #f0f0f0;
    padding: 20px;
    box-sizing: border-box;
    border-radius: 3px;

    display: flex;
    flex-flow: column nowrap;
    justify-content: center;
    align-items: center;
  }

  @media (max-width: 800px) {
    #projects .grid {
      --gap: 20px;
    }

    .project.empty {
      display: none;
    }
  }

  @media (max-width: 500px) {
    #projects .grid {
      grid-template-columns: 1fr;
    }

    .project,
    .project:hover {
      transform: none;
      filter: none;
    }
    .givelively {
      height: calc(100vh - 75px);
    }
  }

  @media (max-width: 400px) {
    #splash {
      padding: 40px 20px;
    }
  }
</style>
